VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Const m_Syntax As String = "Pyxia IBasic"
Private Const m_Version As String = "3.00"

Private m_Expl_Const As Boolean
Private m_Insert_After_Option As Boolean
Private m_AutoFormat As Boolean
Private m_ShowParams As Boolean
Private m_Type As String
Public m_Charset As Long

Public Property Let Charset(mCharset)
    m_Charset = mCharset
End Property

Public Property Get VarRanges() As Boolean
    VarRanges = False
End Property

Public Sub mNoRange()
    m_Type = ""
End Sub

Public Sub mPublic()
    m_Type = "Public "
End Sub

Public Sub mPrivate()
    m_Type = "Private "
End Sub

Public Property Get Version() As String
    Version = m_Version
End Property

Public Property Get Syntax() As String
    Syntax = m_Syntax
End Property

Public Function InitPlugIn() As Boolean
    'Return True if Init is successful
    InitPlugIn = True
End Function

Public Property Get ShowParams() As Boolean
    'Only needed for MASM
    ShowParams = False
End Property

Public Property Let ShowParams(m_Use_ShowParams As Boolean)
    m_ShowParams = m_Use_ShowParams
End Property

Public Property Get AutoFormat() As Boolean
    'Return True if the programming langauge
    'supports Declarations in more than one line
    AutoFormat = False
End Property

Public Property Let AutoFormat(m_Use_AutoFormat As Boolean)
    m_AutoFormat = m_Use_AutoFormat
End Property

Public Property Get ExplConst() As Boolean
    'Return True if the programming langauge
    'supports explicit declaration of
    'constants
    ExplConst = False
End Property

Public Property Let ExplConst(m_Use_Expl_Const As Boolean)
    m_Expl_Const = m_Use_Expl_Const
End Property

Public Property Get InsertAfterOption() As Boolean
    InsertAfterOption = False
End Property

Public Property Let InsertAfterOption(m_Use_Insert_After_Option As Boolean)
    m_Insert_After_Option = m_Use_Insert_After_Option
End Property

Public Function GetType(ByVal m_Name As String, ByVal m_Data As String) As String
    Dim i As Long
    m_Data = Replace(m_Data, " As ", ":")
    For i = 1 To 3
        m_Data = Replace(m_Data, Chr(9) & Chr(9), Chr(9))
    Next i
    m_Data = Replace(m_Data, Chr(9) & "DEF " & vbNewLine, "")
    m_Data = Replace(m_Data, Chr(9) & "DEF ", Chr(9))
    m_Data = Replace(m_Data, Chr(9), Chr(9) & "DEF ")
    m_Data = Replace(m_Data, "Long", "INT")
    m_Data = Replace(m_Data, "Byte", "CHAR")
    m_Data = Replace(m_Data, "String", "STRING")
    m_Data = Replace(m_Data, "Integer", "WORD")
    m_Data = Replace(m_Data, "Boolean", "INT")
    m_Data = Replace(m_Data, "Any", "POINTER")
    GetType = "TYPE " & m_Name & vbNewLine & m_Data & vbNewLine & "ENDTYPE"
End Function

Public Function GetEnum(ByVal m_Name As String, ByVal m_Data As String) As String
    GetEnum = "Not Supported"
End Function

Public Function GetConst(m_Name As String, m_Data As String) As String
    GetConst = "CONST " & m_Name & " = " & m_Data
End Function

Public Function GetSub(m_Name As String, m_Data As String) As String
    Dim mBuffer As String
    Dim nPos As Long
    mBuffer = FormatDec(m_Name, m_Data)
    If InStr(mBuffer, ".") < 1 Then
        'add .dll
        nPos = InStr(mBuffer, Chr(34))
        nPos = InStr(nPos + 1, mBuffer, Chr(34))
        mBuffer = Left$(mBuffer, nPos - 1) & ".dll" & Right$(mBuffer, (Len(mBuffer) - nPos) + 1)
    End If
    If m_Charset = 1 Then
        mBuffer = Replace(mBuffer, "A" & Chr(34), "W" & Chr(34))
    Else
        mBuffer = Replace(mBuffer, "W" & Chr(34), "A" & Chr(34))
    End If
    GetSub = mBuffer
End Function

Public Function GetFunc(m_Name As String, m_Data As String) As String
    Dim mBuffer As String
    Dim nPos As Long
    mBuffer = FormatDec(m_Name, m_Data)
    If InStr(mBuffer, ".") < 1 Then
        'add .dll
        nPos = InStr(mBuffer, Chr(34))
        nPos = InStr(nPos + 1, mBuffer, Chr(34))
        mBuffer = Left$(mBuffer, nPos - 1) & ".dll" & Right$(mBuffer, (Len(mBuffer) - nPos) + 1)
    End If
    If m_Charset = 1 Then
        mBuffer = Replace(mBuffer, "A" & Chr(34), "W" & Chr(34))
    Else
        mBuffer = Replace(mBuffer, "W" & Chr(34), "A" & Chr(34))
    End If
    GetFunc = mBuffer
End Function

Private Function FormatDec(m_Name As String, m_Data As String) As String
    Dim tmp As String
    tmp = Left$(m_Data, InStr(m_Data, "(") - 2) & "," & m_Name & "(" & Right$(m_Data, Len(m_Data) - InStr(m_Data, "(") - 1)
    tmp = Replace(tmp, "&", ":INT")
    tmp = Replace(tmp, "%", ":WORD")
    tmp = Replace(tmp, "$", ":STRING")
    tmp = Replace(tmp, "String", "STRING")
    tmp = Replace(tmp, "):", "),")
    tmp = Replace(tmp, "~", "")
    tmp = Replace(tmp, " As ", ":")
    tmp = Replace(tmp, "Any", "POINTER")
    tmp = Replace(tmp, "?", "")
    tmp = Replace(tmp, "(:", "(),")
    FormatDec = "DECLARE " & tmp
End Function

Public Function Preview() As String
    Dim strTemp As String
    strTemp = "CONST Test = 1" & vbNewLine & vbNewLine
    strTemp = strTemp & "DECLARE " & Chr(34) & "MyDLL" & Chr(34) & ",Test (Param1:STRING, Param2:STRING, Param3:STRING, Param4:STRING),INT"
    Preview = strTemp
End Function
